Index: trunk/ab5.0/abdev/abdev/MenuProc.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/MenuProc.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/MenuProc.cpp	(revision 625)
@@ -11,8 +11,8 @@
 #endif
 
-int GetMenuInfoNum(const char *name){
+int GetMenuInfoNum(const std::string &name){
 	int i;
 	for(i=0;i<projectInfo.NumberOfMenu;i++){
-		if(lstrcmpi(name,projectInfo.pMenuInfo[i].IdName)==0) return i;
+		if(lstrcmpi(name.c_str(),projectInfo.pMenuInfo[i].IdName)==0) return i;
 	}
 	return -1;
@@ -68,5 +68,4 @@
 void Project_Menu_Insert(void){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern char NewIdName[MAX_PATH];
 	int i;
@@ -121,5 +120,5 @@
 	////////////////////////////////
 	// ウィンドウ プロパティを更新
-	for(i=0;i<MAX_WNDNUM;i++){
+	for(i=0;i<MdiInfo.size();i++){
 		if(MdiInfo[i].hwnd&&MdiInfo[i].DocType==WNDTYPE_RAD){
 			if(MdiInfo[i].MdiRadInfo->SelectingItem[0]==SELECT_WINDOW)
@@ -132,10 +131,9 @@
 void Project_Menu_Delete(int MenuInfoNum){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
 	//ウィンドウが開かれている場合は閉じる
-	for(i=0;i<MAX_WNDNUM;i++){
-		if(MdiInfo[i].hwnd&&lstrcmpi(projectInfo.pMenuInfo[MenuInfoNum].IdName,MdiInfo[i].path)==0){
+	for(i=0;i<MdiInfo.size();i++){
+		if(MdiInfo[i].hwnd&&lstrcmpi(projectInfo.pMenuInfo[MenuInfoNum].IdName,MdiInfo[i].path.c_str())==0){
 			SendMessage(MdiInfo[i].hwnd,WM_CLOSE,0,0);
 			break;
@@ -166,8 +164,8 @@
 	////////////////////////////////
 	// ウィンドウ プロパティを更新
-	for(i=0;i<MAX_WNDNUM;i++){
+	for(i=0;i<MdiInfo.size();i++){
 		if(MdiInfo[i].hwnd&&MdiInfo[i].DocType==WNDTYPE_RAD){
 			if(MdiInfo[i].MdiRadInfo->SelectingItem[0]==SELECT_WINDOW)
-				ChangePropertyWindow(i,GetWndInfoNum(MdiInfo[i].path));
+				ChangePropertyWindow(i,GetWndInfoNum(MdiInfo[i].path.c_str()));
 		}
 	}
@@ -192,5 +190,4 @@
 	extern HINSTANCE hInst;
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	HWND hChild,hListWnd,hMenuEdit;
@@ -203,5 +200,5 @@
 		i=GetWndNum(hChild);
 		if(MdiInfo[i].DocType==WNDTYPE_MENU){
-			if(lstrcmpi(MdiInfo[i].path,pMenuInfo->IdName)==0) break;
+			if(lstrcmpi(MdiInfo[i].path.c_str(),pMenuInfo->IdName)==0) break;
 		}
 		hChild=GetNextWindow(hChild,GW_HWNDNEXT);
@@ -249,40 +246,38 @@
 		hChild,NULL,hInst,NULL);
 
+
 	//ウィンドウのID登録
-	for(i=0;i<MAX_WNDNUM;i++){
-		if(MdiInfo[i].hwnd==0){
-			MdiInfo[i].hwnd=hChild;
-			MdiInfo[i].DocType=WNDTYPE_MENU;
-			MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(pMenuInfo->IdName)+1);
-			lstrcpy(MdiInfo[i].title,pMenuInfo->IdName);
-			MdiInfo[i].path=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(pMenuInfo->IdName)+1);
-			lstrcpy(MdiInfo[i].path,pMenuInfo->IdName);
-
-
-			/////////////////////
-			//MENU ウィンドウ情報
-
-			MdiInfo[i].MdiMenuInfo=(MDIMENUINFO *)GlobalAlloc(GPTR,sizeof(MDIMENUINFO));
-
-			MdiInfo[i].MdiMenuInfo->hList=hListWnd;
-
-			MdiInfo[i].MdiMenuInfo->hMenuEdit=hMenuEdit;
-			MdiInfo[i].MdiMenuInfo->hEdit_Dlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_PROJECT_MENUEDIT),hMenuEdit,(DLGPROC)MenuEditDlg);
-
-			SCROLLINFO ScrollInfo;
-			ScrollInfo.cbSize=sizeof(SCROLLINFO);
-			ScrollInfo.fMask=SIF_POS;
-			ScrollInfo.nPos=0;
-			SetScrollInfo(MdiInfo[i].MdiMenuInfo->hMenuEdit,SB_VERT,&ScrollInfo,1);
-
-			SendMessage(hListWnd,LB_RESETCONTENT,0,0);
-			SetMenuDataList(hListWnd,pMenuInfo,0);
-			if(pMenuInfo->NumberOfMenu){
-				SendMessage(hListWnd,LB_SETCURSEL,0,0);
-				SendMessage(hChild,WM_COMMAND,MAKELONG(0,LBN_SELCHANGE),(long)hListWnd);
-			}
-			break;
-		}
-	}
+	MdiInfo.push_back( MDIINFO() );
+	i = MdiInfo.size()-1;
+	MdiInfo[i].hwnd=hChild;
+	MdiInfo[i].DocType=WNDTYPE_MENU;
+	MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,lstrlen(pMenuInfo->IdName)+1);
+	lstrcpy(MdiInfo[i].title,pMenuInfo->IdName);
+	MdiInfo[i].path = pMenuInfo->IdName;
+
+
+	/////////////////////
+	//MENU ウィンドウ情報
+
+	MdiInfo[i].MdiMenuInfo=(MDIMENUINFO *)GlobalAlloc(GPTR,sizeof(MDIMENUINFO));
+
+	MdiInfo[i].MdiMenuInfo->hList=hListWnd;
+
+	MdiInfo[i].MdiMenuInfo->hMenuEdit=hMenuEdit;
+	MdiInfo[i].MdiMenuInfo->hEdit_Dlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_PROJECT_MENUEDIT),hMenuEdit,(DLGPROC)MenuEditDlg);
+
+	SCROLLINFO ScrollInfo;
+	ScrollInfo.cbSize=sizeof(SCROLLINFO);
+	ScrollInfo.fMask=SIF_POS;
+	ScrollInfo.nPos=0;
+	SetScrollInfo(MdiInfo[i].MdiMenuInfo->hMenuEdit,SB_VERT,&ScrollInfo,1);
+
+	SendMessage(hListWnd,LB_RESETCONTENT,0,0);
+	SetMenuDataList(hListWnd,pMenuInfo,0);
+	if(pMenuInfo->NumberOfMenu){
+		SendMessage(hListWnd,LB_SETCURSEL,0,0);
+		SendMessage(hChild,WM_COMMAND,MAKELONG(0,LBN_SELCHANGE),(long)hListWnd);
+	}
+
 
 	//ウィンドウ位置を初期化
@@ -332,5 +327,4 @@
 	extern HANDLE hHeap;
 	extern HWND hClient,hOwner;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	char temporary[MAX_PATH];
@@ -744,5 +738,4 @@
 LRESULT CALLBACK MenuEditWindow(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HINSTANCE hInst;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	RECT rect;
@@ -797,5 +790,4 @@
 LRESULT CALLBACK MDIClientWindow_Menu(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3,WndNum,MenuInfoNum;
 	MENU_INFO *pMenuInfo;
Index: trunk/ab5.0/abdev/abdev/MessageCallOperation.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/MessageCallOperation.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/MessageCallOperation.cpp	(revision 625)
@@ -39,7 +39,7 @@
 
 	NameLen=pWindowInfo->GetName().size();
-	CallBackNameLen=lstrlen(pWindowInfo->CallBackName);
-
-	buffer = ReadBuffer( projectInfo.GetWorkDir().GetPath() + pWindowInfo->filepath );
+	CallBackNameLen=pWindowInfo->GetCallbackName().size();
+
+	buffer = ReadBuffer( projectInfo.GetWorkDir().GetPath() + pWindowInfo->GetSourceFileName() );
 
 	*num=0;
@@ -117,5 +117,5 @@
 				i2+=9;
 				while(buffer[i2]==' '||buffer[i2]=='\t') i2++;
-				if(memicmp(buffer+i2,pWindowInfo->CallBackName,CallBackNameLen)==0&&
+				if(memicmp(buffer+i2,pWindowInfo->GetCallbackName().c_str(),CallBackNameLen)==0&&
 					(buffer[i2+CallBackNameLen]==' '||buffer[i2+CallBackNameLen]=='\t'||buffer[i2+CallBackNameLen]=='(')){
 					*pbAlways=1;
@@ -129,5 +129,4 @@
 }
 void SelectProcedureOfMessageCall(int WndInfoNum,char *ProcedureName,char *Parameter){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3,WndNum;
 	char temporary[MAX_PATH],*pBuf;
@@ -137,5 +136,5 @@
 	ActiveBasic::PM::WindowInfo *pWindowInfo = projectInfo.windowInfos[WndInfoNum];
 
-	hChild=OpenFileWithExtension( projectInfo.GetWorkDir().GetPath() + pWindowInfo->filepath );
+	hChild=OpenFileWithExtension( projectInfo.GetWorkDir().GetPath() + pWindowInfo->GetSourceFileName() );
 	if(!hChild) return;
 	WndNum=GetWndNum(hChild);
@@ -216,5 +215,4 @@
 }
 BOOL GetEventProcedureNameFromListView(HWND hList,int WndNum,int WndInfoNum,char *EventName,char *Parameter,DWORD dwEventType){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,MaxCount;
 	char temporary[MAX_PATH];
@@ -394,5 +392,4 @@
 }
 void SetEventToList(HWND hDlg,DWORD dwEventType){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,WndNum;
 	HWND hList;
@@ -586,5 +583,4 @@
 }
 BOOL CALLBACK DlgEventCode(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int WndNum,WndInfoNum,i,i2;
 	char temporary[MAX_PATH],temp2[MAX_PATH];
Index: trunk/ab5.0/abdev/abdev/ParameterHint.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ParameterHint.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ParameterHint.cpp	(revision 625)
@@ -38,11 +38,10 @@
 		lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
 
-		extern MDIINFO MdiInfo[MAX_WNDNUM];
-		for(i=0;i<MAX_WNDNUM;i++){
+		for(i=0;i<MdiInfo.size();i++){
 			if(MdiInfo[i].hwnd){
-				if(lstrcmpi(MdiInfo[i].path,temporary)==0) break;
-			}
-		}
-		if(i==MAX_WNDNUM){
+				if(lstrcmpi(MdiInfo[i].path.c_str(),temporary)==0) break;
+			}
+		}
+		if(i==MdiInfo.size()){
 			//ファイルから開く
 			pBuf=ReadBuffer(temporary);
@@ -56,5 +55,4 @@
 	else{
 		//単体ソースコードのとき
-		extern MDIINFO MdiInfo[MAX_WNDNUM];
 		int WndNum;
 
@@ -682,5 +680,4 @@
 void ShowParameterHint(int WndNum){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern METHODCHECKINFO MethodCheckInfo;
 	int i,i2,i3,IsStr,IsComment,PareNum,iPos;
@@ -1238,5 +1235,4 @@
 		extern HINSTANCE hInst;
 		extern METHODCHECKINFO MethodCheckInfo;
-		extern MDIINFO MdiInfo[MAX_WNDNUM];
 		HDC hdc,memdc;
 		RECT rect,rc2;
Index: trunk/ab5.0/abdev/abdev/ProjectControl.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/ProjectControl.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/ProjectControl.cpp	(revision 625)
@@ -42,5 +42,4 @@
 LRESULT CALLBACK TabProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern LPSTR DefFileFilter;
 	int i,i2,WndNum;
@@ -1057,5 +1056,4 @@
 		windowInfos.push_back( new ActiveBasic::PM::WindowInfo() );
 		windowInfos.back()->SetName( "MainWnd" );
-		windowInfos.back()->SetHandleName( "hMainWnd" );
 		windowInfos.back()->pos.x=CW_USEDEFAULT;
 		windowInfos.back()->pos.y=CW_USEDEFAULT;
@@ -1077,7 +1075,5 @@
 		windowInfos.back()->SetIconResourceName( "" );
 		windowInfos.back()->SetClassName( "NORMAL" );
-		windowInfos.back()->CallBackName="MainWndProc";
-		windowInfos.back()->type=WNDTYPE_DEFAULT;
-		windowInfos.back()->filepath="MainWnd.ab";
+		windowInfos.back()->SetType( ActiveBasic::PM::WindowType::Default );
 		sprintf(temporary,"%s%s.wnd",dir,NewProjectInfo.name);
 
@@ -1244,5 +1240,4 @@
 	//////////////////////////////////////////
 	//ワークファイル（*.wrk）をオープン
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	HTREEITEM hTreeItem;
 	HANDLE hFind;
@@ -1571,5 +1566,4 @@
 }
 BOOL ProjectModifyCheck(BOOL bRun){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum,sw;
 	HWND hChild;
@@ -1601,5 +1595,5 @@
 				for(i=0;i<projectInfo.pobj_DBFileInfo->iNum;i++){
 					projectInfo.pobj_DBFileInfo->ppobj_FileInfo[i]->GetFullPath(temporary);
-					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0) sw=1;
+					if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0) sw=1;
 				}
 			}
@@ -1611,5 +1605,5 @@
 					lstrcpy(temporary,resourceItem.filepath.c_str());
 					lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
-					if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0) sw=1;
+					if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0) sw=1;
 				}
 			}
@@ -1639,5 +1633,4 @@
 }
 void MakeWorkFile(void){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,WndNum;
 	char temporary[MAX_PATH],buffer[32767];
@@ -1658,5 +1651,5 @@
 			for(i=0;i<projectInfo.pobj_DBFileInfo->iNum;i++){
 				projectInfo.pobj_DBFileInfo->ppobj_FileInfo[i]->GetFullPath(temporary);
-				if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 					TextEdit_GetSel(WndNum,&CharRange);
 
@@ -1684,6 +1677,6 @@
 			BOOST_FOREACH( ActiveBasic::PM::WindowInfo *pWindowInfo, projectInfo.windowInfos )
 			{
-				if(lstrcmpi(MdiInfo[WndNum].path,pWindowInfo->GetName().c_str())==0){
-					sprintf(buffer+i2,"rad,%s\r\n",MdiInfo[WndNum].path);
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),pWindowInfo->GetName().c_str())==0){
+					sprintf(buffer+i2,"rad,%s\r\n",MdiInfo[WndNum].path.c_str());
 					i2+=lstrlen(buffer+i2);
 					break;
@@ -1693,6 +1686,6 @@
 		else if(MdiInfo[WndNum].DocType==WNDTYPE_MENU){
 			for(i=0;i<projectInfo.NumberOfMenu;i++){
-				if(lstrcmpi(MdiInfo[WndNum].path,projectInfo.pMenuInfo[i].IdName)==0){
-					sprintf(buffer+i2,"menu,%s\r\n",MdiInfo[WndNum].path);
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),projectInfo.pMenuInfo[i].IdName)==0){
+					sprintf(buffer+i2,"menu,%s\r\n",MdiInfo[WndNum].path.c_str());
 					i2+=lstrlen(buffer+i2);
 					break;
@@ -1705,5 +1698,5 @@
 				lstrcpy(temporary,resourceItem.filepath.c_str());
 				lstrcpy( temporary, projectInfo.GetWorkDir().GetFullPath( temporary ).c_str() );
-				if(lstrcmpi(MdiInfo[WndNum].path,temporary)==0){
+				if(lstrcmpi(MdiInfo[WndNum].path.c_str(),temporary)==0){
 					sprintf(buffer+i2,"icon,%s\r\n",resourceItem.filepath.c_str());
 					i2+=lstrlen(buffer+i2);
Index: trunk/ab5.0/abdev/abdev/RadProc.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/RadProc.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/RadProc.cpp	(revision 625)
@@ -8,5 +8,4 @@
 	extern HINSTANCE hInst,hResInst;
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	HWND hChild;
@@ -19,5 +18,5 @@
 		i=GetWndNum(hChild);
 		if(MdiInfo[i].DocType==WNDTYPE_RAD){
-			if(lstrcmpi(MdiInfo[i].path,windowInfo.GetName().c_str())==0) break;
+			if(lstrcmpi(MdiInfo[i].path.c_str(),windowInfo.GetName().c_str())==0) break;
 		}
 		hChild=GetNextWindow(hChild,GW_HWNDNEXT);
@@ -81,57 +80,53 @@
 	//ウィンドウのID登録
 	HDC hdc;
-	for(i=0;i<MAX_WNDNUM;i++){
-		if(MdiInfo[i].hwnd==0){
-			MdiInfo[i].hwnd=hChild;
-			MdiInfo[i].DocType=WNDTYPE_RAD;
-			MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,windowInfo.GetName().size()+1);
-			lstrcpy(MdiInfo[i].title,windowInfo.GetName().c_str());
-			MdiInfo[i].path=(char *)GlobalAlloc(GMEM_FIXED,windowInfo.GetName().size()+1);
-			lstrcpy(MdiInfo[i].path,windowInfo.GetName().c_str());
-
-
-			////////////////////////////
-			// MDIRADINFO構造体をセット
-			////////////////////////////
-
-			MdiInfo[i].MdiRadInfo=(MDIRADINFO *)GlobalAlloc(GPTR,sizeof(MDIRADINFO));
-
-			MdiInfo[i].MdiRadInfo->hTools=hTools;
-			MdiInfo[i].MdiRadInfo->hProperty=hProperty;
-			MdiInfo[i].MdiRadInfo->hProp_Dlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW),hProperty,(DLGPROC)RadProperty_WindowProc);
-
-			SCROLLINFO ScrollInfo;
-			ScrollInfo.cbSize=sizeof(SCROLLINFO);
-			ScrollInfo.fMask=SIF_POS;
-			ScrollInfo.nPos=0;
-			SetScrollInfo(MdiInfo[i].MdiRadInfo->hProperty,SB_VERT,&ScrollInfo,1);
-
-			MdiInfo[i].MdiRadInfo->hRad=hRad;
-
-			MdiInfo[i].MdiRadInfo->hSupport=hSupport;
-
-			hdc=GetDC(hRad);
-			MdiInfo[i].MdiRadInfo->hBitmap=CreateCompatibleBitmap(hdc,ScreenX*2,ScreenY*2);
-			MdiInfo[i].MdiRadInfo->hMemDC=CreateCompatibleDC(hdc);
-			MdiInfo[i].MdiRadInfo->hOldBitmap=
-				(HBITMAP)SelectObject(MdiInfo[i].MdiRadInfo->hMemDC,MdiInfo[i].MdiRadInfo->hBitmap);
-			ReleaseDC(hRad,hdc);
-
-			for(i2=0;i2<MAX_RAD_SELITEM;i2++) MdiInfo[i].MdiRadInfo->SelectingItem[i2]=-1;
-			MdiInfo[i].MdiRadInfo->ButtonSelect=IDC_TOOL_MOUSE;
-
-			//変更情報を初期化
-			MdiInfo[i].MdiRadInfo->undo.NowPos=0;
-			memset(MdiInfo[i].MdiRadInfo->undo.Command,0,sizeof(int)*MAX_UNDONUM);
-
-
-			DrawRadWindow(i,&windowInfo);
-
-			//サポートダイアログの内容をセット
-			SetSupportDlgData(i,windowInfo);
-
-			break;
-		}
-	}
+	MdiInfo.push_back( MDIINFO() );
+	i = MdiInfo.size()-1;
+
+	MdiInfo[i].hwnd=hChild;
+	MdiInfo[i].DocType=WNDTYPE_RAD;
+	MdiInfo[i].title=(char *)GlobalAlloc(GMEM_FIXED,windowInfo.GetName().size()+1);
+	lstrcpy(MdiInfo[i].title,windowInfo.GetName().c_str());
+	MdiInfo[i].path = windowInfo.GetName();
+
+
+	////////////////////////////
+	// MDIRADINFO構造体をセット
+	////////////////////////////
+
+	MdiInfo[i].MdiRadInfo=(MDIRADINFO *)GlobalAlloc(GPTR,sizeof(MDIRADINFO));
+
+	MdiInfo[i].MdiRadInfo->hTools=hTools;
+	MdiInfo[i].MdiRadInfo->hProperty=hProperty;
+	MdiInfo[i].MdiRadInfo->hProp_Dlg=CreateDialog(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW),hProperty,(DLGPROC)RadProperty_WindowProc);
+
+	SCROLLINFO ScrollInfo;
+	ScrollInfo.cbSize=sizeof(SCROLLINFO);
+	ScrollInfo.fMask=SIF_POS;
+	ScrollInfo.nPos=0;
+	SetScrollInfo(MdiInfo[i].MdiRadInfo->hProperty,SB_VERT,&ScrollInfo,1);
+
+	MdiInfo[i].MdiRadInfo->hRad=hRad;
+
+	MdiInfo[i].MdiRadInfo->hSupport=hSupport;
+
+	hdc=GetDC(hRad);
+	MdiInfo[i].MdiRadInfo->hBitmap=CreateCompatibleBitmap(hdc,ScreenX*2,ScreenY*2);
+	MdiInfo[i].MdiRadInfo->hMemDC=CreateCompatibleDC(hdc);
+	MdiInfo[i].MdiRadInfo->hOldBitmap=
+		(HBITMAP)SelectObject(MdiInfo[i].MdiRadInfo->hMemDC,MdiInfo[i].MdiRadInfo->hBitmap);
+	ReleaseDC(hRad,hdc);
+
+	for(i2=0;i2<MAX_RAD_SELITEM;i2++) MdiInfo[i].MdiRadInfo->SelectingItem[i2]=-1;
+	MdiInfo[i].MdiRadInfo->ButtonSelect=IDC_TOOL_MOUSE;
+
+	//変更情報を初期化
+	MdiInfo[i].MdiRadInfo->undo.NowPos=0;
+	memset(MdiInfo[i].MdiRadInfo->undo.Command,0,sizeof(int)*MAX_UNDONUM);
+
+	DrawRadWindow(i,&windowInfo);
+
+	//サポートダイアログの内容をセット
+	SetSupportDlgData(i,windowInfo);
+
 
 	ShowWindow(hSupport,SW_SHOW);
@@ -160,5 +155,4 @@
 
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,NewItemNum;
 	char temporary[MAX_PATH];
@@ -271,5 +265,4 @@
 void DeleteDlgItem(int WndNum,int WndInfoNum,int ItemNum,BOOL bNoticeChanging){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	ActiveBasic::PM::WindowInfo *pWindowInfo = projectInfo.windowInfos[WndInfoNum];
@@ -335,5 +328,4 @@
 }
 void DrawFrame(HWND hwnd,int WndNum,int WndInfoNum,RECT *NewRect,RECT *OldRect,BOOL bLA){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	static int swLineStop;
 	int i,sw;
@@ -446,5 +438,4 @@
 }
 void GetSelectingRect(int WndNum,int WndInfoNum,int num,RECT *rect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	ActiveBasic::PM::WindowInfo *pWindowInfo = projectInfo.windowInfos[WndInfoNum];
@@ -466,5 +457,4 @@
 }
 void DrawSelectingRect(HWND hwnd,int WndNum,int WndInfoNum,int ButtonSelect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern RADINFO RadInfo;
 	int i,i2,i3;
@@ -541,5 +531,4 @@
 }
 void ChangePropertyWindow(int WndNum,int WndInfoNum){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	RECT rect;
 	SCROLLINFO ScrollInfo;
@@ -603,5 +592,4 @@
 }
 int GetItemNumOnMouse(int WndNum,int WndInfoNum,int x,int y){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
@@ -648,5 +636,4 @@
 void SelectItemNumOnMouse(int WndNum,int WndInfoNum,int x,int y){
 	//マウス座標をもとにコントロールアイテムを選択
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
@@ -671,5 +658,4 @@
 }
 void SetItemNumOnFrame(int WndNum,int WndInfoNum,RECT *pRect){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,sw;
 	RECT rect;
@@ -696,5 +682,4 @@
 }
 int GetStateOfDraggingFrame(int WndNum,int WndInfoNum,int x,int y){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	RECT rect;
@@ -757,5 +742,4 @@
 }
 void ResetScrollbarOfRadEditor(int WndNum,int weight,int height){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	SCROLLINFO ScrollInfo;
 	SIZE NeedSize;
@@ -791,5 +775,4 @@
 }
 LRESULT CALLBACK RadWindow(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern RADINFO RadInfo;
 	int i,i2,i3,i4;
@@ -1964,5 +1947,4 @@
 }
 void ResizeToRadToolWindows(int WndNum,int weight,int height){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	RECT rect;
@@ -2002,5 +1984,4 @@
 LRESULT CALLBACK MDIClientWindow_Rad(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HWND hDocCombo;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,WndNum;
 
Index: trunk/ab5.0/abdev/abdev/RadSupport.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/RadSupport.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/RadSupport.cpp	(revision 625)
@@ -189,5 +189,4 @@
 	// サポートダイアログの内容をセット
 	////////////////////////////////////
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern RADINFO RadInfo;
 	char temporary[255];
@@ -268,5 +267,4 @@
 
 BOOL CALLBACK DlgRadSupport(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	static BOOL bTimer;
 	int i,i3;
Index: trunk/ab5.0/abdev/abdev/RadToolsAndPropertyProc.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/RadToolsAndPropertyProc.cpp	(revision 624)
+++ trunk/ab5.0/abdev/abdev/RadToolsAndPropertyProc.cpp	(revision 625)
@@ -100,5 +100,4 @@
 }
 BOOL CALLBACK RadToolButtonsProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,WndNum;
 	HWND hParent;
@@ -198,5 +197,4 @@
 }
 LRESULT CALLBACK RadToolsWindow(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	extern HFONT hStatusFont;
 	int i;
@@ -352,5 +350,4 @@
 	extern HANDLE hHeap;
 	extern HWND hClient,hOwner;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i3;
 	char temporary[MAX_PATH],temp2[MAX_PATH];
@@ -361,14 +358,7 @@
 				i=GetWndNum(GetWindow(hClient,GW_CHILD));
 				ActiveBasic::PM::WindowInfo *pWindowInfo = GetWndInfo(MdiInfo[i].path);
-				sprintf(temporary,"h%s",pWindowInfo->GetName().c_str());
-				sprintf(temp2,"%sProc",pWindowInfo->GetName().c_str());
-				if( pWindowInfo->GetHandleName() == temporary &&
-					lstrcmp(temp2,pWindowInfo->CallBackName)==0){
-					SendDlgItemMessage(hwnd,IDC_AUTOSET,BM_SETCHECK,BST_CHECKED,0);
-					SendMessage(hwnd,WM_COMMAND,IDC_AUTOSET,0);
-				}
 				SetDlgItemText(hwnd,IDC_WINDOWNAME,pWindowInfo->GetName().c_str());
-				SetDlgItemText(hwnd,IDC_WINDOWHANDLE,pWindowInfo->GetHandleName().c_str());
-				SetDlgItemText(hwnd,IDC_WINDOWPROC,pWindowInfo->CallBackName);
+				SetDlgItemText(hwnd,IDC_WINDOWHANDLE,( "h" + pWindowInfo->GetName() ).c_str());
+				SetDlgItemText(hwnd,IDC_WINDOWPROC,( pWindowInfo->GetName() + "Proc" ).c_str());
 				break;
 			}
@@ -402,16 +392,6 @@
 						names.name = temporary;
 
-						i3=GetWindowTextLength(GetDlgItem(hwnd,IDC_WINDOWHANDLE))+1;
-						GetDlgItemText(hwnd,IDC_WINDOWHANDLE,temporary,i3);
-						names.HandleName = temporary;
-
-						i3=GetWindowTextLength(GetDlgItem(hwnd,IDC_WINDOWPROC))+1;
-						names.CallBackName=(char *)HeapAlloc(hHeap,0,i3);
-						GetDlgItemText(hwnd,IDC_WINDOWPROC,names.CallBackName,i3);
-
-						if( names.name == pWindowInfo->GetName() &&
-							pWindowInfo->GetHandleName() == names.HandleName &&
-							lstrcmp(names.CallBackName,pWindowInfo->CallBackName)==0){
-							HeapDefaultFree(names.CallBackName);
+						if( names.name == pWindowInfo->GetName() )
+						{
 							SendMessage(hwnd,WM_COMMAND,IDCANCEL,0);
 							return 1;
@@ -423,17 +403,8 @@
 						//変更情報を更新
 						NoticeNames.name=pWindowInfo->GetName();
-						NoticeNames.HandleName=pWindowInfo->GetHandleName();
-						NoticeNames.CallBackName=pWindowInfo->CallBackName;
 						Rad_NoticeChanging(i,RAD_UNDO_NAME,SELECT_WINDOW,(DWORD)&NoticeNames);
 
 						pWindowInfo->SetName( names.name );
-						GlobalFree(MdiInfo[i].path);
-						MdiInfo[i].path=(char *)GlobalAlloc(GMEM_FIXED,names.name.size()+1);
-						lstrcpy(MdiInfo[i].path,names.name.c_str());
-
-						pWindowInfo->SetHandleName( names.HandleName );
-
-						HeapDefaultFree(pWindowInfo->CallBackName);
-						pWindowInfo->CallBackName=names.CallBackName;
+						MdiInfo[i].path = names.name;
 
 						EndDialog(hwnd,1);
@@ -444,10 +415,5 @@
 					return 1;
 				case IDC_WINDOWNAME:
-					if(HIWORD(wParam)==EN_CHANGE) SendMessage(hwnd,WM_COMMAND,IDC_AUTOSET,0);
-					return 1;
-				case IDC_AUTOSET:
-					if(SendDlgItemMessage(hwnd,IDC_AUTOSET,BM_GETCHECK,0,0)){
-						SendDlgItemMessage(hwnd,IDC_WINDOWHANDLE,EM_SETREADONLY,1,0);
-						SendDlgItemMessage(hwnd,IDC_WINDOWPROC,EM_SETREADONLY,1,0);
+					{
 						GetDlgItemText(hwnd,IDC_WINDOWNAME,temporary,MAX_PATH);
 						if(temporary[0]){
@@ -462,8 +428,4 @@
 						}
 					}
-					else{
-						SendDlgItemMessage(hwnd,IDC_WINDOWHANDLE,EM_SETREADONLY,0,0);
-						SendDlgItemMessage(hwnd,IDC_WINDOWPROC,EM_SETREADONLY,0,0);
-					}
 					return 1;
 			}
@@ -473,5 +435,4 @@
 }
 BOOL CALLBACK DlgRadProperty_Window_ExStyle(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
@@ -544,5 +505,4 @@
 BOOL CALLBACK RadProperty_WindowProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i3,i4;
 	static BOOL bInitial;
@@ -568,6 +528,6 @@
 					SendDlgItemMessage(hwnd,IDC_BGCOLOR,CB_ADDSTRING,0,(long)resourceItem.idName.c_str());
 				}
-				if(pWindowInfo->type==WNDTYPE_MODALDLG||
-					pWindowInfo->type==WNDTYPE_MODELESSDLG){
+				if( pWindowInfo->IsModalDlg() || pWindowInfo->IsModelessDlg() )
+				{
 					SendDlgItemMessage(hwnd,IDC_BGCOLOR,CB_SETCURSEL,0,0);
 					EnableWindow(GetDlgItem(hwnd,IDC_BGCOLOR),0);
@@ -688,14 +648,19 @@
 				//////////
 				//タイプ
-				switch(pWindowInfo->type){
-					case WNDTYPE_DEFAULT:
-						SendDlgItemMessage(hwnd,IDC_DEFWINDOW,BM_SETCHECK,BST_CHECKED,0);
-						break;
-					case WNDTYPE_MODALDLG:
-						SendDlgItemMessage(hwnd,IDC_MODALDLG,BM_SETCHECK,BST_CHECKED,0);
-						break;
-					case WNDTYPE_MODELESSDLG:
-						SendDlgItemMessage(hwnd,IDC_MODELESSDLG,BM_SETCHECK,BST_CHECKED,0);
-						break;
+				if( pWindowInfo->IsDefaultWindow() )
+				{
+					SendDlgItemMessage(hwnd,IDC_DEFWINDOW,BM_SETCHECK,BST_CHECKED,0);
+				}
+				else if( pWindowInfo->IsModalDlg() )
+				{
+					SendDlgItemMessage(hwnd,IDC_MODALDLG,BM_SETCHECK,BST_CHECKED,0);
+				}
+				else if( pWindowInfo->IsModelessDlg() )
+				{
+					SendDlgItemMessage(hwnd,IDC_MODELESSDLG,BM_SETCHECK,BST_CHECKED,0);
+				}
+				else
+				{
+					throw;
 				}
 
@@ -1115,12 +1080,18 @@
 
 						//変更情報
-						Rad_NoticeChanging(i,RAD_UNDO_TYPE,SELECT_WINDOW,pWindowInfo->type);
+						Rad_NoticeChanging(i,RAD_UNDO_TYPE,SELECT_WINDOW,(DWORD)pWindowInfo->GetType());
 
 						if(SendDlgItemMessage(hwnd,IDC_DEFWINDOW,BM_GETCHECK,0,0))
-							pWindowInfo->type=WNDTYPE_DEFAULT;
+						{
+							pWindowInfo->SetType( ActiveBasic::PM::WindowType::Default );
+						}
 						else if(SendDlgItemMessage(hwnd,IDC_MODALDLG,BM_GETCHECK,0,0))
-							pWindowInfo->type=WNDTYPE_MODALDLG;
+						{
+							pWindowInfo->SetType( ActiveBasic::PM::WindowType::ModalDlg );
+						}
 						else if(SendDlgItemMessage(hwnd,IDC_MODELESSDLG,BM_GETCHECK,0,0))
-							pWindowInfo->type=WNDTYPE_MODELESSDLG;
+						{
+							pWindowInfo->SetType( ActiveBasic::PM::WindowType::ModelessDlg );
+						}
 						return 1;
 					}
@@ -1134,5 +1105,4 @@
 BOOL CALLBACK DlgRadProperty_Item_RenameCaption(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i3;
 	char *temporary;
@@ -1267,5 +1237,4 @@
 	extern HANDLE hHeap;
 	extern HWND hClient,hOwner;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i3;
 	char *temporary;
@@ -1323,5 +1292,4 @@
 BOOL DefaultItemStyles(HWND hwnd,int WndNum,int WndInfoNum,WPARAM wParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 
 	ActiveBasic::PM::WindowInfo *pWindowInfo = projectInfo.windowInfos[WndInfoNum];
@@ -1389,5 +1357,4 @@
 }
 BOOL CALLBACK DlgRadProperty_Item_ExStyle(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 
@@ -1451,5 +1418,4 @@
 
 BOOL CALLBACK RadProperty_ButtonProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -1673,5 +1639,4 @@
 // CHECKBOX プロパティ
 BOOL CALLBACK RadProperty_CheckBoxProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -1964,5 +1929,4 @@
 }
 BOOL CALLBACK RadProperty_ComboBoxProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -2232,5 +2196,4 @@
 }
 BOOL CALLBACK RadProperty_EditProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -2518,5 +2481,4 @@
 
 BOOL CALLBACK RadProperty_GroupBoxProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -2670,5 +2632,4 @@
 BOOL CALLBACK RadProperty_ImageBoxProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
 	extern HANDLE hHeap;
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	char temporary[MAX_PATH];
@@ -3066,5 +3027,4 @@
 // LISTVIEW プロパティ
 BOOL CALLBACK RadProperty_ListViewProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -3358,5 +3318,4 @@
 }
 BOOL CALLBACK RadProperty_ListBoxProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -3616,5 +3575,4 @@
 // PROGRESSBAR プロパティ
 BOOL CALLBACK RadProperty_ProgressBarProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	static BOOL bInitial;
@@ -3701,5 +3659,4 @@
 
 BOOL CALLBACK RadProperty_RadioButtonProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -3935,5 +3892,4 @@
 
 BOOL CALLBACK RadProperty_ScrollBarProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -4020,5 +3976,4 @@
 
 BOOL CALLBACK RadProperty_StaticProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -4151,5 +4106,4 @@
 // TRACKBAR プロパティ
 BOOL CALLBACK RadProperty_TrackBarProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -4304,5 +4258,4 @@
 // TREEVIEW プロパティ
 BOOL CALLBACK RadProperty_TreeViewProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2;
 	static BOOL bInitial;
@@ -4516,5 +4469,4 @@
 // UPDOWN プロパティ
 BOOL CALLBACK RadProperty_UpDownProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i,i2,i3;
 	static BOOL bInitial;
@@ -4689,5 +4641,4 @@
 
 LRESULT CALLBACK RadPropertyWindow(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	extern MDIINFO MdiInfo[MAX_WNDNUM];
 	int i;
 	RECT rect;
